/******************************************************************************
 * file:  Rule.java
 * author:  Dirk Zitterell
 * description:  a single rule Object for the turing machine
 *****************************************************************************/

import java.io.*;

public class Rule {
    /* variables */
    private int state;
    private char read;
    private char write;
    private char move;
    private int nextState;

    /* empty constructor */
    public Rule() {
	this.state = -1;
	this.read = '*';
	this.write = '*';
	this.move = '*';
	this.nextState = -1;
    }

    /* constructor */
    public Rule(int state, char read, char write, char move, int nextState) {
	this.state = state;
	this.read = read;
	this.write = write;
	this.move = move;
	this.nextState = nextState;
    }

    /* returns the state */
    public int getState() {
	return this.state;
    }

    /* sets the state */
    public void setState(int state) {
	this.state = state;
    }

    /* returns the read character */
    public char getRead() {
	return this.read;
    }

    /* sets the read character */
    public void setRead(char read ) {
	this.read = read;
    }

    /* returns the write character */
    public char getWrite() {
	return this.write;
    }

    /* sets the write character */
    public void setWrite(char write) {
	this.write = write;
    }

    /* returns the move character */
    public char getMove() {
	return this.move;
    }

    /* sets the move character */
    public void setMove(char move) {
	this.move = move;
    }

    /* returns the next state */
    public int getNextState() {
	return this.nextState;
    }

    /* sets the next state */
    public void setNextState(int nextState) {
	this.nextState = nextState;
    }

    /* returns a String representing this rule */
    public String toString() {
	String str = "";
	str += this.state + "\t";
	str += this.read + "\t";
	str += this.write + "\t";
	str += this.move + "\t";
	str += this.nextState + "\n";
	return str;
    }
}
